#! /usr/bin/pythonw -i
# -*- coding: iso-8859-1 -*-

# Multisend er en enkel Python-applikasjon for Nokia Series 60-
# telefoner, og lar deg p rasjonelt vis overfre bilder du
# har tatt til en PC via Bluetooth, og deretter slette dem.
# Bildene vil bli gitt nye navn basert p tidspunktet de ble tatt.
#
# OBS: Programmet er ikke grundig testet i det hele tatt, og
#      kan i verste fall slette filer du ikke vil miste.
#      Bruk p egen risiko.
#
# Laget av Audun@Vaaler.info, 28.2.06. Gjr hva du vil med koden.

# Katalogen hvor bilder fra telefonens kamera lagres. Befinner
# seg muligens et annet sted p din telefon.
DIR = r'e:\Images'

import socket, os, stat, time
import appuifw, e32

# glob-modulen finnes ikke for S60
inNames = [name for name in os.listdir(DIR) if name.endswith(".jpg")]
numFiles = len(inNames)

res = appuifw.query(u"Really send and delete %i files?" % numFiles, "query")

count = 0

# Hvis brukeren svarer nei, er res == None
if res:
    # Sk etter Bluetooth-enheter
    address, services = socket.bt_obex_discover()
    sv0 = services.values()[0]
    
    for inName in inNames:
        print "%s (%i/%i)" % (inName, count + 1, numFiles)
        
        inPath = os.path.join(DIR, inName)
        created = os.stat(inPath)[stat.ST_MTIME] # Tidspunkt for oppretting
        outName = time.strftime(u"ms_%Y%m%d_%H%M%S.jpg", time.localtime(created))
        outPath = os.path.join(DIR, outName)

        # Dp om - fila sendes nemlig med det navnet den har lokalt
        os.rename(inPath, outPath)

        # Send fila via Bluetooth
        socket.bt_obex_send_file(address, sv0, unicode(outPath))

        # Slett fila
        os.unlink(outPath)

        # Gi andre prosesser tid
        e32.ao_yield()

        count += 1
else:
    appuifw.note(u'Not sending files', "info")
