#! /usr/bin/pythonw -i
# -*- coding: iso-8859-1 -*-

# Webcam
#
# Dette er et eksempel p en enkel Python-applikasjon for Nokia
# Series 60-telefoner.
#
# Programmet tar et bilde med telefonens innebygde kamera, og
# sender det til en webserver. P webserveren trenger du
# CGI-skriptet cellr.cgi, som flger med.
#
# OBS: Programmet er ikke grundig testet i det hele tatt.
#      Det er ikke sikkert at det virker p din telefon.
#
# Laget av Audun@Vaaler.info, 28.2.06. Gjr hva du vil med koden.

import os, urllib
import appuifw, camera, e32

# URL til cellr.cgi. Fyll den inn her, s slipper du mye
# skriving p telefonen.
DEFAULT_URL = u''
TMP_PATH = u'e:\\System\\Data\\webcam.jpeg'

# Innkapsling i en klasse gjr ting ryddigere
class WebcamApp:
    def __init__(self):
        # Ta vare p tittelen, slik at den kan settes tilbake
        # nr programmet avsluttes.
        self.prevTitle = appuifw.app.title
        appuifw.app.title = u"Webcam"

        appuifw.app.exit_key_handler = self.Exit
        appuifw.app.body = appuifw.Canvas()

        # Finn minste stttede bildestrrelse
        sizes = camera.image_sizes()
        sizes.sort()
        self.imageSize = sizes[0]

        self.stopped = False

    def Log(self, msg):
        w = appuifw.app.body.size[0]
        h = 14

        # Fyll omrdet med hvitt, og skriv over
        appuifw.app.body.rectangle((0, 0, w, h), fill = (255, 255, 255))
        appuifw.app.body.text((2, h - 1), msg)

    def Send(self, img):
        # Vi m lagre til fil for  f tak i JPEG-dataene
        img.save(TMP_PATH, format = 'JPEG', quality = 25, compression = 'best')
        jpeg = open(TMP_PATH).read()
        os.unlink(TMP_PATH)

        name = "webcam.jpg"

        # Send til server
        data = urllib.urlencode({"name": name, "file": jpeg})
        urllib.urlopen(self.url, data)

    def CleanUp(self):
        # For ordens skyld setter vi vindustittelen til det den var fr
        appuifw.app.title = self.prevTitle

    def Run(self):
        # Spr brukeren om URL
        self.url = appuifw.query(u'URL for mottak', 'text', DEFAULT_URL)

        # Avslutt hvis brukeren trykker Cancel
        if self.url == None:
            self.CleanUp()
            return

        # Kjr til vi har registrert et Exit-klikk
        while not self.stopped:
            self.Log(u'Tar bilde...')
            img = camera.take_photo(size = self.imageSize)

            x = appuifw.app.body.size[0] / 2 - img.size[0] / 2
            y = appuifw.app.body.size[1] / 2 - img.size[1] / 2

            appuifw.app.body.blit(img, target = (x, y))
            self.Log(u'Tok bilde. Sender...')
            self.Send(img)

            self.Log(u'Bilde ble sendt. Sover...')
            e32.ao_sleep(1)
        
        self.CleanUp()

    def Exit(self):
        self.stopped = True

def Main():
    app = WebcamApp()
    app.Run()

if __name__ == "__main__":
    Main()
